﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using System.Data.Odbc;
using System.Data.SqlClient;
using ADODB;
using System.Diagnostics;
using System.IO;
//using System.Threading;


namespace CursorPerfTest.subClass
{
    class CursorPerfTest
    {

        public static List<ResponseTime> responseTime = new List<ResponseTime>();

        public static void 결과시간누적(int 반복_증가값_현재값, int 단위_테스트_현재값, double 소요시간)
        {
            ResponseTime RT = new ResponseTime(반복_증가값_현재값, 단위_테스트_현재값, 소요시간);
            responseTime.Add(RT);
        }

        public static ADODB.Connection cn = new ADODB.Connection();
        public static ADODB.Recordset rs = new ADODB.Recordset();
        
        static void Main(string[] args)
        {
            Config.로컬_연결스트링 = args[0].ToString();
            Config.원격_연결스트링 = args[1].ToString();
            Config.쿼리 = args[2].ToString();
            Config.반복_증가값 = args[3].ToString();
            Config.반복_증가값_최대값 = args[4].ToString();
            Config.단위_테스트_횟수 = args[5].ToString();

            설정확인();
            메뉴선택();
        }

        public static void 설정확인()
        {
            Console.WriteLine("+------------------------------------------------------------------------------------+"); 
            Console.WriteLine(" Local_constr  : {0} ", Config.로컬_연결스트링);
            Console.WriteLine(" Remote_constr : {0} ", Config.원격_연결스트링);
            Console.WriteLine(" Query         : {0} ", Config.쿼리);
            Console.WriteLine(" R_Inc         : {0}", Config.반복_증가값);
            Console.WriteLine(" R_Inc_Max     : {0}", Config.반복_증가값_최대값);
            Console.WriteLine(" Test_Times    : {0}", Config.단위_테스트_횟수);
            Console.WriteLine("+------------------------------------------------------------------------------------+");
            Console.WriteLine("");
        }

        public static void 메뉴선택()
        {
            Console.WriteLine("+------------------------------------------------------------------------------------+");
            Console.WriteLine(" Please select one ");
            Console.WriteLine("");
            Console.WriteLine(" 1: ADODB Local Server ");
            Console.WriteLine(" 2: ADODB Remote Server ");
            Console.WriteLine(" 3: Save Result (c:\\result.txt) ");
            Console.WriteLine(" 9: EXIT ");
            Console.WriteLine("+------------------------------------------------------------------------------------+");
            Console.WriteLine(cn.State.ToString());
            String Selection = Console.ReadLine();

            switch (Selection)
            {
                case "1":
                    반복수행(Config.로컬_연결스트링);
                    break;
                case "2":
                    반복수행(Config.원격_연결스트링);
                    break;
                case "3":
                    결과저장();
                    break;
                case "9":
                    return;
                default :
                    메뉴선택();
                    break;
            }

        }

        public static void 결과저장()
        {
            FileStream fs = new FileStream("c:\\result.txt", FileMode.Append, FileAccess.Write, FileShare.Write);
            fs.Close();
            StreamWriter sw = new StreamWriter("c:\\result.txt", true, Encoding.ASCII);
            sw.WriteLine(Config.테스트_시간.ToString());
            sw.WriteLine("+------------------------------------------------------------------------------------+");
            sw.WriteLine(" Current_Con_Str    : \t {0} ", Config.현재_연결스트링);
            sw.WriteLine(" Query              : \t {0} ", Config.쿼리);
            sw.WriteLine(" R_Inc              : \t {0}", Config.반복_증가값);
            sw.WriteLine(" R_Inc_Max          : \t {0}", Config.반복_증가값_최대값);
            sw.WriteLine(" Test_Times         : \t {0}", Config.단위_테스트_횟수);
            sw.WriteLine("+------------------------------------------------------------------------------------+");
            foreach (ResponseTime RT in responseTime)
            {
                sw.WriteLine(RT.반복_증가값_현재값.ToString() + "|" + RT.단위_테스트_횟수_현재값.ToString() + "|" + RT.소요시간.ToString());
            }
            sw.Close();
            메뉴선택();
        }

        public static void 반복수행(string 연결스트링)
        {
            responseTime.Clear();
            Config.현재_연결스트링 = 연결스트링;
            Config.테스트_시간 = DateTime.Now;

            for (int 반복_증가값_현재값 = 1; 반복_증가값_현재값 <= int.Parse(Config.반복_증가값_최대값); 반복_증가값_현재값 = 반복_증가값_현재값 * int.Parse(Config.반복_증가값))
            {
                // 캐시사이즈를 2배 증가시켜 실행
                for (int 단위_테스트_현재값 = 1; 단위_테스트_현재값 <= int.Parse(Config.단위_테스트_횟수); 단위_테스트_현재값++)
                {
                    // 반복 회수만큼 테스트 수행 (평균값을 구하기 위해)
                    //Console.WriteLine(반복_증가값_현재값.ToString());
                    //Console.WriteLine(단위_테스트_현재값.ToString());
                    using (new OperationTimer(반복_증가값_현재값, 단위_테스트_현재값))
                    {
                        지정된_캐시사이즈로_쿼리수행(연결스트링, 반복_증가값_현재값);
                    }
                }
            }

            메뉴선택();
        }



        public static void 지정된_캐시사이즈로_쿼리수행(string 연결스트링, int 캐시사이즈)
        {
            string ColValue = "";
            //Console.WriteLine("연결스트링 : {0}, 캐시사이즈 : {1}",연결스트링, 캐시사이즈);
            cn.Open(연결스트링, null, null, 0);
            rs.CursorLocation = CursorLocationEnum.adUseServer;
            rs.Open(Config.쿼리, cn, CursorTypeEnum.adOpenDynamic, LockTypeEnum.adLockPessimistic, -1);
            rs.MoveFirst();
            rs.CacheSize = 캐시사이즈;
            while (!rs.EOF)
            {
                for (int i = 0; i < rs.Fields.Count; i++)
                {
                    ColValue = ColValue + rs.Fields[i].Value.ToString() + "\t";
                }
                //Console.Write(ColValue);
                //Console.WriteLine();
                ColValue = "";
//                Thread.Sleep(1);
                rs.MoveNext();
            }
            rs.Close();
            cn.Close();
        }


    }
}

