﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace CursorPerfTest.subClass
{
    public static class Config // 설정을 위한 값들
    {
        public static string 로컬_연결스트링;
        public static string 원격_연결스트링;
        public static string 쿼리;
        public static string 반복_증가값;
        public static string 반복_증가값_최대값;
        public static string 단위_테스트_횟수;
        public static string 현재_연결스트링;
        public static DateTime 테스트_시간;
    }

    internal sealed class OperationTimer : IDisposable // 성능 측정을 위한 클래스
    {
        private Int64 m_startTime;
        private int v_반복_증가값_현재값;
        private int v_단위_테스트_현재값;
        private Int32 m_commectionCount;
        public OperationTimer(int 반복_증가값_현재값, int 단위_테스트_현재값)
        {
            PrepareForOperation();

            v_반복_증가값_현재값 = 반복_증가값_현재값;
            v_단위_테스트_현재값 = 단위_테스트_현재값;
            m_commectionCount = GC.CollectionCount(0);
            m_startTime = Stopwatch.GetTimestamp();
        }

        public void Dispose()
        {
            //Console.WriteLine("{0,6:###.00} seconds (GCs={1,3}) {2}", (Stopwatch.GetTimestamp() - m_startTime) / (Double)Stopwatch.Frequency, GC.CollectionCount(0) - m_commectionCount, v_반복_증가값_현재값);
            //Console.WriteLine((Stopwatch.GetTimestamp() - m_startTime) / (Double)Stopwatch.Frequency);
            //ResponseTime RT = new ResponseTime(v_반복_증가값_현재값, v_단위_테스트_현재값, (Stopwatch.GetTimestamp() - m_startTime) / (Double)Stopwatch.Frequency);
            //responseTime.Add(RT);
            Console.WriteLine("Cur_CacheSize : {0}, Cur_Test_Times : {1}, Duration : {2}", v_반복_증가값_현재값, v_단위_테스트_현재값, (Stopwatch.GetTimestamp() - m_startTime) / (Double)Stopwatch.Frequency);
            CursorPerfTest.결과시간누적(v_반복_증가값_현재값, v_단위_테스트_현재값, (Stopwatch.GetTimestamp() - m_startTime) / (Double)Stopwatch.Frequency);
        }
        private static void PrepareForOperation()
        {
            GC.Collect();
            GC.WaitForPendingFinalizers();
            GC.Collect();
        }
    }

    // 성능 결과를 담을 데이터 형식 정의
    public class ResponseTime
    {
        private int v_반복_증가값_현재값;
        private int v_단위_테스트_횟수_현재값;
        private double v_소요시간;

        public ResponseTime(int 반복_증가값_현재값, int 단위_테스트_횟수_현재값, double 소요시간)
        {
            v_반복_증가값_현재값 = 반복_증가값_현재값;
            v_단위_테스트_횟수_현재값 = 단위_테스트_횟수_현재값;
            v_소요시간 = 소요시간; 
        }

        public int 반복_증가값_현재값
        {
            get { return v_반복_증가값_현재값; }
            set { v_반복_증가값_현재값 = value; }
        }

        public int 단위_테스트_횟수_현재값
        {
            get { return v_단위_테스트_횟수_현재값; }
            set { v_단위_테스트_횟수_현재값 = value; }
        }

        public double 소요시간
        {
            get { return v_소요시간; }
            set { v_소요시간 = value; }
        }
    }
}
